SystemOrganization addCategory: #'A4BP-BPMN20-view'!
SystemOrganization addCategory: 'A4BP-BPMN20-view-Visualization'!

!A4BPVCBuilder methodsFor: '*A4BP-BPMN20-view-Visualization' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:47'!
visitBPMN20Object: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	A4BPVCBuilder subclasses
		do: [ :c | 
			|builder|
			builder := c new.
			visualizations addAll: (aModel accept: builder) ].
	^ visualizations! !

A4BPVCBuilder subclass: #BPMN20VCBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:31'!
visitBPMN20DefinitionsImpl: aModel
	| visualizations bpvc|
	visualizations := OrderedCollection new.
	self setVisualizationForAllModel: visualizations inModel: aModel.
	bpvc := BPMN20StandarVisualization new bpObj: aModel.
	visualizations add: bpvc.
	
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:49'!
visitBPMN20Object: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:31'!
visitBPMN20ProcessImpl: aModel
	| visualizations bpvc|
	visualizations := self visitBPProcess: aModel.

	bpvc := BPMN20SimpleCluster new bpObj: aModel.
	visualizations add: bpvc.

	bpvc := BPMN20StandarVisualization new bpObj: aModel.
	visualizations add: bpvc.
	^ visualizations! !

A4BPVCBPProcess subclass: #BPMN20SimpleCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20SimpleCluster methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 3/15/2015 00:44'!
executeVisualization: view
	| v model c |
	v := RTMondrian new.
	v view: view.
	view @ RTDraggableView .
	model := bpObj.
	c := A4BPUIBPModelColorBuilderVisitor new.
	
	"Execute the visulization"
	
	c:= A4BPUIBVFactory colorVisitor.
	v shape circle size:10;color:[:n|n accept:c].
	v nodes: model elements.
	v edges notUseInLayout;
	connectToAll: [:n|n outFlows].
	v layout cluster.
	v build.! !

A4BPVCBPProcess subclass: #BPMN20StandarVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVisualization methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 3/23/2015 09:20'!
executeVisualization: view
	| model cv eb nodes mnodes  |
	view @ RTDraggableView.
	model := bpObj.
	cv:= A4BPUIBVFactory colorVisitor.
	nodes :=  model allChildrens.
	"Start the visualization"
		
	nodes
		do: [ :el |
			el shape 
				ifNotNil: [ 
					| point es|
					point := el shape bounds x @ el shape bounds y.
					es := (RTBox new width: 20;height: 20;
					color:[:n | n accept:cv];elementOn: el) 
					translateTo: point.
					es @ RTDraggable @ RTPopup.
					es when: TRMouseClick do: [ :evt | evt element model inspect ].
					view add: es.
					] 
				].
	RTNest new for: view elements add: [ :group :esmodel | 
		group addAll: (Array with:((RTLabel new) elementOn: esmodel aName)).
		RTGridLayout on: group.
	].
	
	eb := RTEdgeBuilder new.
	eb view: view.
	eb shape arrowedLine color: Color black.
	eb objects: nodes from: #yourself toAll: [ :e |  e flows].
	
	mnodes := nodes select: [ :e | e class = BPMN20MessageFlowImpl ].
	eb objects: mnodes from: [ :e |  e sourceRef] to: [ :e |  e targetRef].
	
	eb notUseInLayout.
	! !
